#!/usr/local/bin/perl -Tw
#
#
$version="2.2.3IM";
#
# (c) 1997-1998 Emmanuel PIERRE
#          epierre@mail.esiea.fr
#          http://www.esiea.fr/public_html/Emmanuel.PIERRE
#
# Developed at/by:
#          Ecole Suprieure d'Informatique-Electronique-Automatique
#          a project of the School Web Server
#
#          http://www.esiea.fr
#
#
require 5.002;
#use strict;
BEGIN { $ENV{PATH} = '/usr/bin:/bin' }
use Socket;
use Carp;

sub spawn;  # forward declaration
sub logmsg { 
	#print "$0 $$: @_ at ", scalar localtime, "\n" 
}

$hostname=`/bin/hostname`;
chomp($hostname);
$hostname.=".";
#$hostname.=`/bin/domainname`;
$hostname.="esiea.fr";
#chomp($hostname);

&log_pid;

my $port = shift || 12345;
my $proto = getprotobyname('tcp');

socket(Server, PF_INET, SOCK_STREAM, $proto)        || die "socket: $!";
setsockopt(Server, SOL_SOCKET, SO_REUSEADDR,
                                    pack("l", 1))   || die "setsockopt: $!";
bind(Server, sockaddr_in($port, INADDR_ANY))        || die "bind: $!" ;
listen(Server,SOMAXCONN)                            || die "listen: $!";

logmsg "server started on port $port";

my $waitedpid = 0;
my $paddr;

my $server_name = "http://hp1.esiea.fr:2001";
my $pere_pid=$$;

#
# Traitement des signaux
#
$SIG{'INT'} = 'close_all';
$SIG{'QUIT'} = 'close_all';
$SIG{'USR2'} = 'close_all';
$SIG{'PIPE'} = 'close_cli';

sub REAPER {
               $SIG{CHLD} = \&REAPER;  # loathe sysV
               $waitedpid = wait;
               logmsg "reaped $waitedpid" . ($? ? " with exit $?" : '');
           }

$SIG{CHLD} = \&REAPER;

#
# Boucle d'attente de connection
#
for ( $waitedpid = 0;
     ($paddr = accept(Client,Server)) || $waitedpid;
      $waitedpid = 0, close Client)
           {
               next if $waitedpid;
               my($port,$iaddr) = sockaddr_in($paddr);
               my $name = gethostbyaddr($iaddr,AF_INET);

               logmsg "connection from $name [",
                       inet_ntoa($iaddr), "]
                       at port $port";

               spawn sub {
 			&gere_connection(*Client);
               };

           }
#
# Spawning de base
#
sub spawn {
               my $coderef = shift;
               unless (@_ == 0 && $coderef && ref($coderef) eq 'CODE') {
                   confess "usage: spawn CODEREF";
               }

               my $pid;
               if (!defined($pid = fork)) {
                   logmsg "cannot fork: $!";
                   return;
               } elsif ($pid) {
                   logmsg "begat $pid";
                   return; # i'm the parent
               }
               # else i'm the child -- go spawn

               #open(STDIN,  "<&Client")   || die "can't dup client to stdin";
               #open(STDOUT, ">&Client")   || die "can't dup client to stdout";
               ## open(STDERR, ">&STDOUT") || die "can't dup stdout to stderr";
               exit &$coderef();
           }
#
# Routine de gestion d'une connection
#
sub gere_connection
{
    local(*Client) = $_[0];

    $buffer="";

    syswrite(Client, "MoXWorld Web Server v$version (C)Emmanuel PIERRE 1997\n", length("MoXWorld Web Server v$version (C)Emmanuel PIERRE 1997\n"));

   my $code_ret=0;

    while (1)
    {
	last if (sysread(Client, $buffer, 512)<=0);

        #code_ret = recv(Client, $buffer, 512,0);

        #print STDOUT "Recu : >", $buffer, "<\n";
	
	# bricolage pour mauvaise connection...
	#$counter++;
	
	#if ($counter>10) {
	#	&close_all;
	#}
        
	#last if ($buffer =~ /BYE/);
        last if ($buffer eq "BYE\r\n");

        if (($buffer=~/SHUTDOWN/)) {
                kill('USR2',$pere_pid);
                #print "kill USR2 $pere_pid\n";
                &close_all;
        }
	
	if ($buffer eq "IDENT\r\n") {
                $buffer="IDENT= $hostname:$port\r\n\r\n";
                syswrite(Client, $buffer, length($buffer));
        }

        if  ($buffer eq "GET pages\r\n") {
                #
                # Moulinette
                #
                &get_pages;
                foreach $id (keys %pageres) {
                        $buffer="$pageres{$id}\n";
                        syswrite(Client, $buffer, length($buffer));
                }
        last;
        }
        if  ($buffer eq "GET activ\r\n") {
                #
                # Moulinette
                #
                &get_activ;
                foreach $id (keys %activres) {
                        $buffer="$activres{$id}\n";
                        syswrite(Client, $buffer, length($buffer));
                }
        last;
        }
        if  ($buffer eq "GET proj\r\n") {
                #
                # Moulinette
                #
                &get_proj;
                foreach $id (keys %projres) {
                        $buffer="$projres{$id}\n";
                        syswrite(Client, $buffer, length($buffer));
                }
        last;
        }
        if  ($buffer eq "GET cv\r\n") {
                #
                # Moulinette
                #
                &get_cv;
                foreach $id (keys %cvres) {
                        $buffer="$cvres{$id}\n";
                        syswrite(Client, $buffer, length($buffer));
                }
        last;
        }
        if  ($buffer eq "GET dob\r\n") {
                #
                # Moulinette
                #
                &get_dob;
                foreach $id (keys %dobres) {
			(@liste)=split(/\n/,$dobres{$id});
 			while (@liste) {
				$loc=pop(@liste);
                        	$buffer="$id\t$loc\n";
                        	syswrite(Client, $buffer, length($buffer));
			}
                }
        last;
        }
    	#$buffer= "Unknown command !\n\n";
    	#syswrite(Client, $buffer, length($buffer));
    	#last;
    }

    #print "Closing connection.\n";
    close(Client);
}

sub close_all
{
    shutdown(Client, 2);
    shutdown(Server, 2);
    #print "Server shutdown... Goodbye.\n";
    exit(0);
}
sub close_cli
{
    shutdown(Server, 2);
    #print "Server shutdown... Goodbye.\n";
    exit(0);
}

sub get_pages {

        # Read the real name from passwd file

        open(PW,"/etc/passwd");
        while (<PW>) {
                chop;
                ($user,$pw,$uid,$gid,$gcos,$dir) = split(/:/);
                ($real) = split(/,/, $gcos);
                if ($uid>10) {
                        push @tliste, $user.":".$real.":".$dir."\n";
                }
        }
        close(PW);

        @tliste = sort @tliste;
        @tliste = reverse @tliste;

        while (@tliste) {
                ($user,$real,$dir)=split(/:/,pop @tliste);
                chomp($dir);
                chomp($real);
                chomp($user);

                $nom="";
                $url="";

                if (-r $dir."/.webpagelist") {
                        # si on a affaire  une liste
                        open(FIC,$dir."/.webpagelist");

                        while(<FIC>) {
                                chomp;
                                ($nom,$real,$url,$logo)=split(/\t/,$_);
				chomp($nom);
				chomp($url);
				chomp($real);
				chomp($logo);
                                if ($url ne "") {
                                        $pageres{$nom}="$nom\t$url\t$real\n";
                                        #print "1-$pageres{$nom}";
                                }
                        }
                        close(FIC);
                } else {
                        if (-r $dir."/.webredirect") {
                                open(FIC,$dir."/.webredirect");
                                $url=<FIC>;
                                close(FIC);
				chomp($url);	
                        } else {
                                if (-r $dir."/Welcome.html") {
                                        $url="$server_name$dir/Welcome.html";
                                }
                                if (-r $dir."/public_html/index.html") {
                                        $url="$server_name/~$user/index.html";
                                }
                                if ($url ne "") {
                                        $pageres{$user}="$user\t$url\t$real\n";
                                        #print "2-$pageres{$user}";
                                }
                        }
                }
        }
}

sub get_cv {

        # Read the real name from passwd file

        open(PW,"/etc/passwd");
        while (<PW>) {
                chop;
                ($user,$pw,$uid,$gid,$gcos,$dir) = split(/:/);
                ($real) = split(/,/, $gcos);
                if ($uid>10) {
                        push @tliste, $user.":".$real.":".$dir."\n";
                }
        }
        close(PW);

        @tliste = sort @tliste;
        @tliste = reverse @tliste;

        while (@tliste) {
                ($user,$real,$dir)=split(/:/,pop @tliste);
                chomp($dir);
                chomp($real);
                chomp($user);
                $nom="";
                $url="";

                if (-r $dir."/.webcvlist") {
                        # si on a affaire  une liste
                        open(FIC,$dir."/.webcvlist");

                        while(<FIC>) {
                                chomp;
                                ($nom,$real,$url,$logo)=split(/\t/,$_);
				chomp($nom);
				chomp($url);
				chomp($real);
				chomp($logo);
                                if ($url ne "") {
                                        $cvres{$nom}="$nom\t$url\t$real\n";
                                        #print "1-$cvres{$nom}";
                                }
                        }
                        close(FIC);
                } else {
                        if (-r $dir."/.webcvredirect") {
                                open(FIC,$dir."/.webcvredirect");
                                $url=<FIC>;
                                close(FIC);
				chomp($url);	
                        } else {
                                if (-r $dir."/cv.html") {
                                        $url="$server_name$dir/cv.html";
                                }
                                if (-r $dir."/public_html/cv/index.html") {
                                        $url="$server_name/~$user/cv/index.html";
                                }
                                if ($url ne "") {
                                        $cvres{$user}="$user\t$url\t$real\n";
                                        #print "2-$cvres{$user}";
                                }
                        }
                }
        }
}


sub get_activ {

        # Read the real name from passwd file

        open(PW,"/etc/passwd");
        while (<PW>) {
                chop;
                ($user,$pw,$uid,$gid,$gcos,$dir) = split(/:/);
                ($real) = split(/,/, $gcos);
                if ($uid>10) {
                        push @tliste, $user.":".$real.":".$dir."\n";
                }
        }
        close(PW);

        @tliste = sort @tliste;
        @tliste = reverse @tliste;

        while (@tliste) {
                ($user,$real,$dir)=split(/:/,pop @tliste);
                chomp($dir);
                chomp($user);
                chomp($real);

                $nom="";
                $logo="";
                $url="";

                if (-r $dir."/.webactivlist") {
                        # si on a affaire  une liste
                        open(FIC,$dir."/.webactivlist");

                        while(<FIC>) {
                                chomp;
                                ($nom,$url,$logo)=split(/\t/,$_);
				chomp($nom);
				chomp($url);
				chomp($logo);
                                if ($url ne "") {
                                        $activres{$nom}="$nom\t$url\t$logo\n";
                                        #print "1-$activres{$nom}";
                                }
                        }
                        close(FIC);
                } else {
                        if (-r $dir."/.webactivname") {
                                open(FIC,$dir."/.webactivname");
                                $nom=<FIC>;
                                close(FIC);
				chomp($nom);
                                if (-r $dir."/.webactivredirect") {
                                        open(FIC,$dir."/.webactivredirect");
                                        $url=<FIC>;
                                        close(FIC);
					chomp($url);
                                } else {
                                        if (-r $dir."/public_html/activ/index.html") {
                                                $url="$server_name/~$user/activ/index.html";
                                        }
                                }
                                if (-r $dir."/public_html/activ/minilogo.gif") {
                                        $logo="$server_name/~$user/activ/minilogo.gif";
                                }
                                if ($url ne "") {
                                        $activres{$nom}="$nom\t$url\t$logo\n";
                                        #print "2-$activres{$nom}";
                                }
                        }
                        if ((-r $dir."/.webtpfhname")) {
                                open(FIC,$dir."/.webtpfhname");
                                $nom=<FIC>;
                                close(FIC);
				chomp($nom);	
                                if (-r $dir."/.webtpfhredirect") {
                                        open(FIC,$dir."/.webtpfhredirect");
                                        $url=<FIC>;
                                        close(FIC);
					chomp($url);
                                } else {
                                        if (-r $dir."/public_html/tpfh/index.html") {
                                                $url="$server_name/~$user/tpfh/index.html";
                                        }
                                }
                                if (-r $dir."/public_html/tpfh/minilogo.gif") {
                                        $logo="$server_name/~$user/tpfh/minilogo.gif";
                                }
                                if ($url ne "") {
                                        $activres{$nom}="$nom\t$url\t$logo\n";
                                        #print "3-$activres{$nom}";
                                }
                        }
                }
        }
}

sub get_proj {

        # Read the real name from passwd file

        open(PW,"/etc/passwd");
        while (<PW>) {
                chop;
                ($user,$pw,$uid,$gid,$gcos,$dir) = split(/:/);
                ($real) = split(/,/, $gcos);
                if ($uid>10) {
                        push @tliste, $user.":".$real.":".$dir."\n";
                }
        }
        close(PW);

        @tliste = sort @tliste;
        @tliste = reverse @tliste;

        while (@tliste) {
		$nom="";
		$logo="";
                ($user,$real,$dir)=split(/:/,pop @tliste);
                chomp($dir);
		chomp($real);
		chomp($user);

                if (-r $dir."/.webprojlist") {
                        # si on a affaire  une liste
                        open(FIC,$dir."/.webprojlist");

                        while(<FIC>) {
                                chomp;
                                ($nom,$url,$logo)=split(/\t/,$_);
				chomp($nom);
				chomp($url);
				chomp($logo);
                                if ($url ne "") {
                                        $projres{$nom}="$nom\t$url\t$logo\n";
                                        #print "1-$projres{$nom}";
                                }
                        }
                        close(FIC);
                } else {
                        if (-r $dir."/.webprojname") {
                                open(FIC,$dir."/.webprojname");
                                $nom=<FIC>;
                                close(FIC);
				chomp($nom);
                                if (-r $dir."/.webprojredirect") {
                                        open(FIC,$dir."/.webprojredirect");
                                        $url=<FIC>;
                                        close(FIC);
					chomp($url);
                                } else {
                                        if (-r $dir."/public_html/proj/index.html") {
                                                $url="$server_name/~$user/proj/index.html";
                                        }
                                }
                                if (-r $dir."/public_html/proj/minilogo.gif") {
                                        $logo="$server_name/~$user/proj/minilogo.gif";
                                }
                                if ($url ne "") {
                                        $projres{$nom}="$nom\t$url\t$logo\n";
                                        #print "2-$projres{$nom}";
                                }
                        }
                }
        }
}

sub get_dob {

        # Read the real name from passwd file

        open(PW,"/etc/passwd");
        while (<PW>) {
                chop;
                ($user,$pw,$uid,$gid,$gcos,$dir) = split(/:/);
                ($real) = split(/,/, $gcos);
                if ($uid>10) {
                        push @tliste, $user.":".$real.":".$dir."\n";
                }
        }
        close(PW);

        @tliste = sort @tliste;
        @tliste = reverse @tliste;

        while (@tliste) {
                ($user,$real,$dir)=split(/:/,pop @tliste);
                chomp($dir);
                chomp($real);
                chomp($user);
		my $dater="";
                my $nom=""; my $url=""; my $email=""; my $d1=""; my $d2=""; my $d3=""; my $DOB="";

                if (-r $dir."/.webDOBlist") {
                        # si on a affaire  une liste
                        open(FIC,$dir."/.webDOBlist");

		while(<FIC>) {
                                chomp;
                                ($DOB,$nom,$url,$email)=split(/\t/,$_);
                                ($d1,$d2,$d3)=split(/ /,$DOB);
                                $dater="$d2 $d1 $d3";
                                if (($nom ne "")&&($dater ne "")) {
                                        $dobres{$dater}.="$nom\t$url\t$email\n";
                                        #print "1-$hash{$dater}";
                                }
                        }
                        close(FIC);
                } else {
			if  (-r $dir."/public_html/perso/DOB") {
                                 open(FIC,$dir."/public_html/perso/DOB");
                                 $DOB=<FIC>;
                                 close(FIC);
                                 chomp($DOB);
                                 ($d1,$d2,$d3)=split(/ /,$DOB);
                                 $dater="$d2 $d1 $d3";
                                 $email="$user\@$hostname";
                                 chomp($email);

	                        if (-r $dir."/.webredirect") {
        	                        open(FIC,$dir."/.webredirect");
                	                $url=<FIC>;
                        	        close(FIC);
					chomp($url);	
	                        } else {
        	                        if (-r $dir."/Welcome.html") {
                	                        $url="$server_name$dir/Welcome.html";
                        	        }
                                	if (-r $dir."/public_html/index.html") {
                                        	$url="$server_name/~$user/index.html";
                                	}
				}
				chomp($dater);
                                if ($dater ne "  ") {
                                        $dobres{$dater}.="$real\t$url\t$email\n";
                                        #print "2-$hash{$dater}";
                                }
			}
		}
	}
}

sub log_pid {

	open(FICA,">./srv.pid");
	print FICA "$$\n";
	close(FICA);

}
